import java.awt.Color;
import java.util.GregorianCalendar;

public class ExamClockwork implements Runnable {
	
	private static final long serialVersionUID = 1L;
	private static ExamClockwork ecw;
    private static Thread counterThread;
    
	private static String s;
	private static Color currentColour;
	private static boolean reset, okToRun;
	
	//to call the thread
	private static int timeStep = 10000;
	
	//Maximum, e.g. 90 in Millisecs
	private static Long maxDelta = new Long (90*60*1000);
	
	//turn color to green : warning
	private static Long trigger1 = new Long (5*60*1000);

	//turn color to red : danger
	private static Long trigger2 = new Long (1*60*1000);
	
	//to know when the exam started
	private static GregorianCalendar start;
	
	private static long delta, counter, hours, min, sec = 0;

	private ExamClockwork(){
		super();
		init();
       	counterThread 	= new Thread(this);
		counterThread.start();
	}
	
	public void init(){
		reset 			= 	false;
		start 			= 	new GregorianCalendar();
		currentColour	= 	Color.black;
		s				=	"init";
		delta			=	0;
	}
	
	public void run(){
        while(okToRun == true)
        {
        	if(reset == true){
        		init();
        	}else{       	
        	  try {
            	  Thread.sleep(timeStep);
              } catch (InterruptedException e) {}
        
        	}
        }
	}
	
	//start new
	public void setReset(boolean r){
		reset = r;
	}
	
	//stop thread
	public void setStop(boolean r){
		okToRun = r;
	}

	//start new
	public void setMaxDelta(long r){
		maxDelta = new Long(r*60*1000);
	}

	private void process(){
		delta = maxDelta.longValue() - (new GregorianCalendar().getTimeInMillis()- start.getTimeInMillis());

		//check wheter to siplay secons or not
		if(delta > trigger1.longValue()){
			calculateRemainingTime();
			s =String.valueOf(hours) + "h " + String.valueOf(min) + "min verbleiben.";
		}else if(delta > trigger2.longValue() && delta <= trigger1.longValue()){
			currentColour= Color.green;
			calculateRemainingTime();
			s = String.valueOf(hours) + "h " + String.valueOf(min) + "min " + String.valueOf(sec) + "sec verbleiben.";
		}else if(delta <= trigger2.longValue()){
			currentColour= Color.red;
			calculateRemainingTime();
			s =String.valueOf(hours) + "h " + String.valueOf(min) + "min " + String.valueOf(sec) + "sec verbleiben.";
		}
	}

	public static ExamClockwork getExamClockwork(){
		if(ecw == null){
			ecw = new ExamClockwork();
			return(ecw);
		}else
		{
			return(ecw);
		}
	}
	
	private void calculateRemainingTime(){
		hours = delta / 3600000;
		delta = delta - (hours * 3600000);
		min = delta / 60000;
		delta = (delta - (min * 60000))/1000;
		sec = delta;
	}

	public Color getCurrentColour(){
		return(currentColour);
	}
	
	public String getString(int i){
		process();
		return(s);
	}

	public String getString(){
		return(s);
	}
}