import java.applet.Applet;
import java.awt.Color;
import java.awt.Graphics;

public class ExamCounter extends Applet implements Runnable {

	private static final long serialVersionUID = 1L;
	
	//miliseconds to draw new time
	int timeStep = 10000;
	private ExamClockwork ecw;
	private Thread counterThread;
	private boolean okToRun;
	
	public void init(){
		
		//get clockwork
		ecw=ExamClockwork.getExamClockwork();
		 
		//set maximum minutes
		Integer m = Integer.valueOf(getParameter("max"));
		if(m.intValue() > 0){
			ecw.setMaxDelta(m.longValue());
		}
		
		//set background
		setBackground(Color.white);
		
		okToRun=true;
 	}
	
	
	public void start(){
		//check wheter to start new counter
		if(getParameter("reset").equals("true"))
		{
			okToRun=false;
			try {
            	Thread.sleep(timeStep*2);
            } catch (InterruptedException e) {}
			
            ecw.setStop(false);
			
            init();
		}

		//start thread
		counterThread = new Thread(this);
		counterThread.start();
	}
	
	public void run(){
        while(okToRun == true)
        {
        	repaint();
            try {
            	Thread.sleep(timeStep);
            } catch (InterruptedException e) {}
        }
	}
	
	public void paint(Graphics screen){
		screen.setColor(Color.white);
		screen.drawString(ecw.getString(),15,15);

		screen.setColor(ecw.getCurrentColour());
		screen.drawString(ecw.getString(1),15,15);
	}
}